(unwatch all)
(watch facts)
(deftemplate temp
  0 100 degrees-C
   (
    (low  (0 1)  (25 0))
    (med  (20 0) (50 1) (80 0))
    (high (75 0) (100 1))
   )
)
(defrule moment-defuzzify-test
  (moment)
  ?x <- (temp ?)
=>
  (printout t "****** moment ******" crlf)
  (printout t "Defuzzified value is " (moment-defuzzify ?x) crlf)
  (printout t "****** moment ******" crlf)
) 
(defrule maximum-defuzzify-test
  (max)
  (temp ?fv)
=>
  (printout t "****** maximum ******" crlf)
  (printout t "Defuzzified value is " (maximum-defuzzify ?fv) crlf)
  (printout t "****** maximum ******" crlf)
) 
(reset)
(assert (moment) (temp low))
(run)
(reset)
(assert (max) (temp low))
(run)
(reset)
(assert (moment) (temp med))
(run)
(reset)
(assert (max) (temp med))
(run)
(reset)
(assert (moment) (temp high))
(run)
(reset)
(assert (max) (temp high))
(run)
(reset)
(assert (moment) (temp low OR high))
(run)
(reset)
(assert (max) (temp low OR high))
(run)
(reset)
(assert (moment) (temp med OR high))
(run)
(reset)
(assert (max) (temp med OR high))
(run)
(reset)
(assert (moment) (temp (PI 5.0 50)))
(run)
(reset)
(assert (max) (temp (PI 5.0 50)))
(run)
(reset)
(assert (moment) (temp (0 0) (10 .5) (20 .25) (30 .75) (40 .25) (50 .5) (60 0)))
(run)
(reset)
(assert (max) (temp (0 0) (10 .5) (20 .25) (30 .75) (40 .25) (50 .5) (60 0)))
(run)
(reset)
(assert (moment) (temp (0 0) (25 1) (50 1) (75 0)))
(run)
(reset)
(assert (max) (temp (0 0) (25 1) (50 1) (75 0)))
(run)
(reset)
(assert (moment) (temp (0 1) (20 1) (25 .66666) (45 .66666) (50 .33333)))
(run)
(reset)
(assert (max) (temp (0 1) (20 1) (25 .66666) (45 .66666) (50 .33333)))
(run)
(reset)
(assert (moment) (temp (0 0) (5 1) (15 1) (20 0) (25 1) (30 0)))
(run)
(reset)
(assert (max) (temp (0 0) (5 1) (15 1) (20 0) (25 1) (30 0)))
(run)
(reset)
(printout t "Maximum for fuzzy value 'temp low' is " (maximum-defuzzify
          (create-fuzzy-value temp low)) crlf)
(printout t "Moment for fuzzy value 'temp low' is " (moment-defuzzify
          (create-fuzzy-value temp low)) crlf)


